{ Don Haw - National Geodetic Survey
  http://www.ngs.noaa.gov/GPS/SP3_format.html }
program ToRestorePositionFromSP3Data ; { IGS }
uses
  UnConTyp , { types constants }
  UnForPrt , { var prtf Text file }
  UnrfNorS , { proc ToReadNoradElem }
  UnrSptre , { proc ToReadSptre for current file }
  UnRefrOl , { proc SimpleDataForRefraction }
  UnHarmCS , { proc HarmCSValue }
  UnForSop , { global var SatReflCoef }
  UnTreDoi , { proc ForOrbitImprove }
  UnTreRog ; { proc ToRestoreSatPos }
var
  ft  : Text ;      { file to read text information }
  el  : TElemRec ;  { record from UnConTyp for elements before adjust }
  em  : TElemRec ;  { record from UnConTyp for elements after  adjust }
  sf  : string ; { name of two-line elements file to read from text file }
  sp  : string ; { pattern from name of satellite to read elements }
  ia  : Byte ;   { simple count for files }
  na  : Byte ;   { number of files with data in SP3 format for this object }
  sn  : string ; { name of text file with data in SP3 format }
  sg  : string ; { pattern from name of satellite to read data }
  sr  : string ; { name of text file with Earth rotation parameters }
begin
  assign(prtf,'reglorbi.prt');
  rewrite(prtf);             { var prtf text file from UnForPrt }
  assign(ft,'reglorbi.ini'); { file with initial information }
  reset(ft);                 { to open tect file to read }
  readln(ft);                { the first simple string }
  readln(ft,sf);             { name of tle file with elements }
  readln(ft,sp);             { name of satellite in this tle file }
  ToReadNoradElem(sf,sp,el); { proc from UnrfNorS record el for elements }
  readln(ft,sg);             { name of satellite to read data SP3 format }
  readln(ft,na);             { number of files with data in SP3 format }
  ia:=0;                     { initial nullo for count of files }
repeat                       { file by file with data }
  ia:=ia+1;                  { the next file with data Un}
  readln(ft,sn);             { name of text file with data in SP3 format }
  readln(ft,sr);             { name of text file with ERP }
  ToReadSptre(ia,sg,sn,sr);  { proc from UnrSptre data position  xyz.tmp }
until  ia = na ;             { list of files is ended }
  SimpleDataForRefraction ;  { from UnRefrOl }
  SatReflCoef:=0.0;          { global var from UnForSop }
  HarmCSValue ;              { UnHarmCS to fill arrays czon ctes stes }
  ForOrbitImprove(el,em);    { proc from UnTreDoi orbit improvement }
  writeln(prtf);
  writeln(prtf,' t',el.t:20:10,em.t:20:10);
  writeln(prtf,' e',el.ae:20:10,em.ae:20:10,(el.ae-em.ae):20:10);
  writeln(prtf,' i',el.ai:20:10,em.ai:20:10,(el.ai-em.ai):20:10);
  writeln(prtf,' O',el.au:20:10,em.au:20:10,(el.au-em.au):20:10);
  writeln(prtf,' o',el.ao:20:10,em.ao:20:10,(el.ao-em.ao):20:10);
  writeln(prtf,' M',el.am:20:10,em.am:20:10,(el.am-em.am):20:10);
  writeln(prtf,' n',el.an:20:10,em.an:20:10,(el.an-em.an):20:10);
  writeln(prtf);
  readln(ft,na);             { number of files to prognoz and compare }
  ia:=0;                     { initial count value for file to compare }
repeat                       { just to read file by file }
  ia:=ia+1;                  { the next file proc from UnrSptre }
  DateForRestore(ft,ia,sr);  { to read date from initial file to print result }
until  ia = na ;             { list of dates is ended to file xyz.tmp }
  ToRestoreSatPos(em);       { UnTreRog by using xyz.tmp }
  close(ft);                 { our text file with initial information }
  close(prtf);               { our text file for result }
end.
