
unit UKelmTle ; { to work with tle data }
                { by using doctor T.S.Kelso procedures }
interface

uses
  UnConTyp ; { type TVect3 }

{ to obtain position velosity
  from two-line elements format
  with procedures presented by doctor T.S.Kelso }

procedure DoctorKelso ( sa , sb  : string ;   { tc epoch for elements }
                        var  tc  : Extended ; { modified julian day } 
                        var  rr  : TVect3 ;   { position UnConTyp }
                        var  vv  : TVect3 ) ; { velosity UnConTyp }

implementation

uses
  UKelsoIf , {SGP_IntF for global variables sat_data and other }
  UKelsoCo , {SGP_Conv proc Convert_... }
  UKelsoMa , {SGP_Math type vector }
  UKelsoTi , {SGP_Time}
  UKelsoTh ; {SGP4SDP4}

{ to obtain position velosity
  from two-line elements format
  with procedures presented by doctor T.S.Kelso }

procedure DoctorKelso ( sa , sb  : string ;   { tc epoch for elements }
                        var  tc  : Extended ; { modified julian day } 
                        var  rr  : TVect3 ;   { position UnConTyp }
                        var  vv  : TVect3 ) ; { velosity UnConTyp }
var
  time     : double ;
  pos,vel  : vector ; { type UKelsoMa }
begin

  sat_data[1,1]:=sa; { to keep in array the first  line UKelsoIf }
  sat_data[1,2]:=sb; { to keep in array the second line UKelsoIf }

  Convert_Satellite_Data(1);   { unit UKelsoCo SGP_Conv }

  time:=Julian_Date_of_Epoch(epoch); { unit UKelsoTi SGP_Time UKelsoIf }

  SGP(time,pos,vel);           { unit UKelsoTh SGP4SDP4 }

  Convert_Sat_State(pos,vel);  { unit UKelsoCo SGP_Conv }

  tc:=time-DifEpoch; { constant UnConTyp }

  rr[1]:=pos[1]; { x coordinate in km }
  rr[2]:=pos[2]; { y coordinate in km }
  rr[3]:=pos[3]; { z coordinate in km }

  vv[1]:=vel[1]; { v_x coordinate in km/s }
  vv[2]:=vel[2]; { v_y coordinate in km/s }
  vv[3]:=vel[3]; { v_z coordinate in km/s }

end;

end.
 