 UNIT UnConTyp ;
 INTERFACE
 Const
   JD2000   = 2451545.0 ;
   JulianC  =   36525.0 ;
   DifEpoch = 2400000.5 ;
   MJD2000  = JD2000-DifEpoch ;
 Const
   GaussConst       = 0.0172020989500000e0 ;
                   { in AstrUnit**3/((Ephemer.Day**2)*MassOfSun if in Sqr }
   CavendishConst   = 6.672e-20 ;     { in km**3/(kg*s**2) }
   AstrUnit         = 1.49597870691e8 ;  { in km }
   VelOfLight       = 299792.4580 ;   { in km/s }
 Const
   GeoFM    = 3.986004415e5 ; { km**3/s**2 JGM3 }
   GeoR0    = 6.378136300e3 ; { km JGM3 }
 Const
   Pi22     = 2 * Pi ;
   GraRad   = Pi / 180 ;
   RadGra   = 180 / Pi ;
   SecRad   = GraRad / 3600 ;
   RadSec   = 3600 / GraRad ;
 Type
   TVect3    = Array [1..3] of Extended ;
   TMatr33   = Array [1..3] of TVect3 ;
   TFundArg  = Array [1..5] of Extended ;
 Type
   { for the Earth satellites indentification and middle elements }
   TElemRec        = Record
                        satnord  : LongInt ;  { number from NORAD }
                        satnuml  : LongInt ;  { number launch date }
                        satname  : String[20] ;
                        stdmag   : Single ;   { standard magnitude }
                        t , ao , au , ai , ae , am , an , dn  : Extended ;
                     End ;
 IMPLEMENTATION
 END.
