
 { to construct right hand side of the equations of the motion }

 UNIT  UnForceM ;

 INTERFACE

 Uses
   UnConTyp ; { for TVect = Array[1..3] of Extended }

 { InPut
    rr - vector of position in km
   OutPut
    Force - vector of the main force due to one point attraction }

 Procedure TheMainForce ( rc  : TVect3 ;  Var  force  : TVect3 ) ;

 IMPLEMENTATION

 { the Earth as a material point with a mass M }

 Procedure TheMainForce ( rc  : TVect3 ;  Var  force  : TVect3 ) ;
 Var
   r,rr,rrr,fmr   : Extended ;
 Begin
   { to take into account the main force from the Earth  }
   rr:=1/(Sqr(rc[1])+Sqr(rc[2])+Sqr(rc[3]));
   r:=Sqrt(rr); { r is invariant for rotation of the systems }
   rrr:=r*rr; { 1/r , 1/r**2 , 1/r**3 }
   fmr:=GeoFM*rrr; { GeoFM from UnConTyp }
   force[1]:=-fmr*rc[1];
   force[2]:=-fmr*rc[2];
   force[3]:=-fmr*rc[3];
 End;

 END.
