
 { some procedures for pseudoinversion }

 UNIT UnMatInv ;

 INTERFACE

 Uses
   UnMatDer ; { for MatrN MatrM and all types }

 Procedure PseudoInverse ( AMatr          : TypeDimNM ;
                           NumN , NumM    : Integer ;
                           Epsilon        : Extended ;
                           Var  MatrRank  : Integer ;
                           Var  MatrVect  : TypeDimInt ;
                           Var  BMatr     : TypeDimMN ) ;

 IMPLEMENTATION

 { PseudoInverse is a procedure
     to inverse matrix in form  AMatr(NumN,NumM) to BMatr(NumM,NumN) ,
        algorithm have been presented by doctor Albert . }

 procedure PseudoInverse ( AMatr           : TypeDimNM ;
                           NumN , NumM     : Integer ;
                           Epsilon         : Extended ;
                           Var  MatrRank   : Integer ;
                           Var  MatrVect   : TypeDimInt ;
                           Var  BMatr      : TypeDimMN ) ;
 Var
   I,J,M0,M1,IM : Integer ;
   C2           : Extended ;
   CM,CK,CC     : TypeDimN ;
   CA           : TypeDimM ;
 Begin
   MatrRank:=0; IM:=NumM;
   For M1:=1 To NumM Do
     Begin
       M0:=M1-1; C2:=0;
       For I:=1 To NumN  Do  Begin
         CC[I]:=AMatr[I,M1]; CM[I]:=AMatr[I,M1];
         C2:=C2+Sqr(CM[I]);  End;
       If  C2 < Epsilon  Then
         Begin
           For I:=1 To NumN Do  CK[I]:=0;
           MatrVect[IM]:=M1; IM:=IM-1;
           For I:=1 To NumN Do  BMatr[M1,I]:=CK[I];
         End
                          Else
         Begin
           If  MatrRank = 0  Then
             Begin
               For I:=1 To NumN Do  CK[I]:=CM[I]/C2;
               MatrVect[1]:=M1; MatrRank:=1;
               For I:=1 To NumN Do  BMatr[M1,I]:=CK[I];
             End
                       Else
             Begin
               For J:=1 To M0 Do
                 Begin
                   CA[J]:=0;
                   For I:=1 To NumN Do  CA[J]:=CA[J]+BMatr[J,I]*CM[I];
                   For I:=1 To NumN Do  CC[I]:=CC[I]-CA[J]*AMatr[I,J];
                 End;
               C2:=0;  For I:=1 To NumN Do  C2:=C2+Sqr(CC[I]);
               If  C2 < Epsilon Then
                 Begin
                   C2:=0; MatrVect[IM]:=M1; IM:=IM-1;
                   For I:=1 To NumN Do
                     Begin
                       CC[I]:=0;
                       For J:=1 To M0 Do  CC[I]:=CC[I]+CA[J]*BMatr[J,I];
                       C2:=C2+CM[I]*CC[I];  End;
                   C2:=C2/(1+C2);
                   For I:=1 To NumN Do  CK[I]:=C2*CC[I];
                 End
                                Else
                 Begin
                   C2:=0; MatrRank:=MatrRank+1; MatrVect[MatrRank]:=M1;
                   For I:=1 To NumN Do  C2:=C2+CM[I]*CC[I];
                   C2:=1.0/C2;  For I:=1 To NumN Do  CK[I]:=C2*CC[I];
                 End;
               For J:=1 To M0 Do
                 For I:=1 To NumN Do
                   BMatr[J,I]:=BMatr[J,I]-CA[J]*CK[I];
               For I:=1 To NumN Do  BMatr[M1,I]:=CK[I];
             End;
         End;
     End;
 End;

 END.
