
 { some procedures to start and finish orbit improving }

 UNIT UnTreDoi ;

 INTERFACE

 Uses
   UnConTyp ; { TVect3 TElemRec }

 Procedure ForOrbitImprove ( var  el , em  : TElemRec ) ;

 IMPLEMENTATION

 Uses
   UnForPrt , { prtf text file }
   UnTreRoc , { proc PosVelToFixEqu PosVelToTruEqu }
   UnForSop , { global variable SatReflCoef }
   UnMatDer , { for derivation file global var numter }
   UnForNor , { proc FromNoradToDesCart }
   UnForStr ; { function FloatToSingle }

 Procedure ToStartImprove ( Var  tb  : Extended ) ;
 Var
   f  : Text ; { text file with t x y z data }
   i  : Byte ;
   m  : Byte ;
   t  : Extended ;
   a  : Extended ;
   b  : Extended ;
   d  : Extended ;
   p  : TVect3 ;
 Begin
   Assign(DerFile,'der.tmp'); { to open to write }
   ReWrite(DerFile);    { variable from UnMatDer }
   Assign(f,'xyz.tmp'); { file with data t x y z }
   ReSet(f);            { to open to read }
   ReadLn(f);           { the first  string with information }
   ReadLn(f);           { the second string with information }
   ReadLn(f,t);         { the first moment in data }
   tb:=t;               { start moment for adjust process }
   With  DerRec  Do     { record for derivations }
     Begin              { DerRec  from  UnMatDer }
       TimeInMJD:=t;    { moment in MJD }
       For i:=1 To 3 Do { initial nullo }
         Begin
           PosEtalon[i]:=0.0;
           x:=0.0; { x pole }
           y:=0.0; { y pole }
           dut:=0.0; { delta UT }
           PosResidual[i]:=0.0;
           PosNulloVar[i]:=0.0;
           For m:=1 To MatrM Do
             PosDerivats[i][m]:=0.0;
         End;
     End;
   ReSet(f);  { to fill with initial values derivation file }
   ReadLn(f); { the first  string with information }
   ReadLn(f); { the second string with information }
   While  NOT EOF(f)  Do
     Begin   { to read x y z position x pole y pole delta UT }
       ReadLn(f,t,p[1],p[2],p[3],a,b,d); { data as observations }
       DerRec.TimeInMJD:=t; { in modified julian day }
       For i:=1 To 3 Do  DerRec.PosEtalon[i]:=p[i]; { position in km }
       DerRec.x:=SecRad*a; { x pole value to radian SecRad }
       DerRec.y:=SecRad*b; { y pole value to radian SecRad }
       DerRec.dut:=d;      { delta Ut in second of time }
       Write(DerFile,DerRec);
     End;
   Close(f);
   Close(DerFile);
 End;

 Procedure ToFinishImprove ( DifPar  : TypeDimM ;
                             tb  : Extended ;
                             Var  rb , vb  : TVect3 ) ;
 Var
   i  : Byte ;
 Begin
   For i:=1 To 3 Do
     Begin { values of the elements after improving process }
       rb[i]:=rb[i]+DifPar[i];
       vb[i]:=vb[i]+DifPar[i+3];
     End;
   SatReflCoef:=SatReflCoef+DifPar[7]; { global var UnForSop }
   WriteLn(' after improving');
   WriteLn(' position and velosity');
   WriteLn('  ',tb:20:10);
   For i:=1 To 3 Do
     WriteLn(i:2,rb[i]:25:15,' km',vb[i]:25:15,' km/s ');
   WriteLn(' reflection coefficient');
   WriteLn('    ',                         { function from UnForStr }
           FloatToSingle(SatReflCoef,20):23,' km/s^2');
   WriteLn(prtf);
   WriteLn(prtf,' after improving');
   WriteLn(prtf);
   WriteLn(prtf,' position and velosity');
   WriteLn(prtf,'  ',tb:20:10);
   For i:=1 To 3 Do
     WriteLn(prtf,i:2,rb[i]:25:15,' km',vb[i]:25:15,' km/s ');
   WriteLn(prtf,' reflection coefficient');
   WriteLn(prtf,'    ',                    { function from UnForStr }
                FloatToSingle(SatReflCoef,20):23,' km/s^2');
 End;

 { to improve elements by using data in xyz.tmp file }

 Procedure ForOrbitImprove ( var  el , em  : TElemRec ) ;
 Var
   tb     : Extended ;  { initial moment nullo }
   ra,va  : TVect3 ; { position velosity true equator }
   rb,vb  : TVect3 ; { position velosity to adjust }
   dparm  : TypeDimM ; { for the correction parameters type UnMatDer }
 Begin
   numter:=0; { global var UnMatDer number of iteration }
   ToStartImprove(tb); { initial nullo to derivation file }
   with  el  do        { initial vector to adjust in rb[1..3] vb[1..3] }
     FromNoradToDesCart(t,ao,au,ai,ae,am,an,dn,tb,ra,va); { UnForNor }
   with  el  do
     begin { initial elements form two line eleemnts file }
       writeln(prtf);
       writeln(prtf,' t',t:20:10);
       writeln(prtf,' e',ae:20:10);
       writeln(prtf,' i',ai:20:10);
       writeln(prtf,' O',au:20:10);
       writeln(prtf,' o',ao:20:10);
       writeln(prtf,' M',am:20:10);
       writeln(prtf,' n',an:20:10);
     end;
   with  em  do  { to change value of the elements after improving }
     FromDesCartToNorad(tb,ra,va,t,ao,au,ai,ae,am,an,dn); { UnForNor }
   el:=em;                         { PosVelToFixEqu from UnTreRoc }
   PosVelToFixEqu(tb,ra,va,rb,vb); { initial position velosity to fixequ }
repeat
   numter:=numter+1;
   WriteLn ;
   WriteLn(' iteration number',numter:4);
   WriteLn(prtf);
   WriteLn(prtf,' iteration number',numter:4);
   WriteLn(prtf);
   ToObtainDerivations(tb,rb,vb) ;  { isochronic derivations UnMatDer }
   ClcVariablesCorrections(dparm);  { from UnMatDer tb start moment }
   ToFinishImprove(dparm,tb,rb,vb); { rb vb vector after improving }
until  ( numter = 4 ) ;             { PosVelToTruEqu from UnTreRoc }
   PosVelToTruEqu(tb,rb,vb,ra,va);  { initial position velosity to truequ }
   with  em  do  { to change value of the elements after improving }
     FromDesCartToNorad(tb,ra,va,t,ao,au,ai,ae,am,an,dn); { UnForNor }
   Erase(DerFile); { our binary file procedure from UnDerMat }
 End;

 END.
