unit UnTreRog ; { for prognoz }
interface
uses
  UnConTyp ; { type TElemRec TVect3 }
{ to prognoz and to compare orbit
  by using data in SP3 format data are in file xyz.tmp }
procedure ForOrbitPrognoz ( el  : TElemRec ) ; { after improving }
{ to obtain position of the satellite
  on selected moment in fixed equator and terra system }
procedure ToRestoreSatPos ( el  : TElemRec ) ; { after improving }
implementation
uses
  UnForNor , { procedure FromNoradToDesCart }
  UnForPrt , { for text file prtf }
  UnForDat , { for procedure TransMJDtoDate }
  UnTreRoc , { procedure VecToTerra }
  UnEveRim ; { for EverGrator }
{ to compare and to write to text file prtf
  vector rt  result of prognoz vector rc from SP3 data file }
procedure CompResult ( tc  : Extended ;  rt , rc  : TVect3 ) ;
var
  nd  : integer ; { day }
  nm  : integer ; { month }
  ny  : integer ; { year }
  kh  : integer ; { hour }
  km  : integer ; { minutr }
  sa  : extended ; { second }
  dx  : extended ; { differences x position in metr }
  dy  : extended ; { differences y position in metr }
  dz  : extended ; { differences z position in metr }
begin
  TransMJDtodate(tc,nd,nm,ny,kh,km,sa); { UnForDat }
  dx:=1.0e3*(rt[1]-rc[1]); { differences x position in metr }
  dy:=1.0e3*(rt[2]-rc[2]); { differences y position in metr }
  dz:=1.0e3*(rt[3]-rc[3]); { differences z position in metr }
  writeln(ny:5,nm:3,nd:3,kh:4,km:3,sa:6:2,dx:12:3,dy:12:3,dz:12:3,' m');
  writeln(prtf,ny:5,nm:3,nd:3,kh:4,km:3,sa:6:2,dx:12:3,dy:12:3,dz:12:3,' m');
end;
{ to write result to text file prtf
  vector rz fixed equator  vector rt terra equator system }
procedure TypeResult ( tc  : Extended ;  rz , rt  : TVect3 ) ;
var               { Earth center - Earth fixed }
  nd  : integer ; { day }
  nm  : integer ; { month }
  ny  : integer ; { year }
  kh  : integer ; { hour }
  km  : integer ; { minutr }
  sa  : extended ; { second }
begin
  TransMJDtodate(tc,nd,nm,ny,kh,km,sa); { UnForDat }
  writeln(ny:5,nm:3,nd:3,kh:4,km:3,sa:6:2,
          rt[1]:16:6,rt[2]:14:6,rt[3]:14:6);
  writeln(prtf,ny:5,nm:3,nd:3,kh:4,km:3,sa:6:2,
               rz[1]:16:6,rz[2]:14:6,rz[3]:14:6,
               rt[1]:16:6,rt[2]:14:6,rt[3]:14:6);
end;
{ to prognoz and to compare orbit
  by using data in SP3 format data are in file xyz.tmp }
procedure ForOrbitPrognoz ( el  : TElemRec ) ; { after improving }
var
  fr  : text ;     { text file xyz.tmp with data }
  ds  : extended ; { step for integration }
  tc  : extended ; { current moment in mjd }
  rc  : TVect3 ;   { type UnConTyp vector terra position in km from data }
  xp  : extended ; { x pole value in arcsec }
  yp  : extended ; { y pole value in arcsec }
  du  : extended ; { current delta UT insecond of time }
  ra  : TVect3 ;   { start position in true equator }
  va  : TVect3 ;   { start velosity in true equator }
  td  : extended ; { for current step start  moment in mjd }
  rd  : TVect3 ;   { for current step start  vector position }
  vd  : TVect3 ;   { for current step start  vector velosity }
  te  : extended ; { for current step finish moment in mjd }
  re  : TVect3 ;   { for current step finish vector position }
  ve  : TVect3 ;   { for current step finish vector velosity }
  rz  : TVect3 ;   { current position vector fixed equator }
  vz  : TVect3 ;   { current velosity vector fixed equator }
  zt  : extended ; { time in second for current step of integration }
  rt  : TVect3 ;   { current position in fixed terra system to compare }
begin
  writeln(prtf);
  writeln(prtf,' to prognoz and to compare positions in metr');
  writeln(prtf);
  td:=el.t;          { moment as start for integration }
  with  el  do       { initial vector to adjust in rb[1..3] vb[1..3] }
     FromNoradToDesCart(t,ao,au,ai,ae,am,an,dn,td,ra,va); { UnForNor }
  PosVelToFixEqu(td,ra,va,rd,vd); { UnTreRoc init pos vel to fixed equator }
  ds:=600.0; { step in second to integrate by numerical method }
  te:=td;    { value mom for EvergGrator }
  re:=rd;    { value pos for EvergGrator }
  ve:=vd;    { value vel for EvergGrator }
  EverInit ;         { from UnEveRim to start EverGrator }
  EverCoefNullo ;    { from UnEveRim to start EverGrator }
  assign(fr,'xyz.tmp'); { text file with data to compare }
  reset(fr);            { to open to read }
  readln(fr);           { the first  information string }
  readln(fr);           { the second information string }
repeat                  { string by string from text file }
  readln(fr,tc,                { current modified julian day with fraction }
            rc[1],rc[2],rc[3], { position in fixed terra system in km }
            xp,yp,du);         { x y pole position and delta UT }
  While  ( te < (tc-1.0e-8) )  Do { to integrate from UnEveRim }
    PosVelEverGrator(ds,td,rd,vd,te,re,ve);    { from UnEveRim }
  zt:=86400.0*(tc-td);                         { interval in second }
  ClcVectFromPolinom(zt,rd,vd,rz,vz);          { proc from UnEveRim }
  VecToTerra(tc,SecRad*xp,SecRad*yp,du,rz,rt); { to terra system with ERParm }
  CompResult(tc,rt,rc); { to compare and to write to text file prtf }
until  EOF(fr);         { from start to end of file }
  close(fr);            { that is all for this file }
  erase(fr);            { no file xyz.tmp now }
end;
{ to obtain position of the satellite
  on selected moment in fixed equator and terra system }
procedure ToRestoreSatPos ( el  : TElemRec ) ; { after improving }
var
  fr  : text ;     { text file xyz.tmp with data }
  ds  : extended ; { step for integration }
  tc  : extended ; { current moment in mjd }
  xp  : extended ; { x pole value in arcsec }
  yp  : extended ; { y pole value in arcsec }
  du  : extended ; { current delta UT insecond of time }
  ra  : TVect3 ;   { start position in true equator }
  va  : TVect3 ;   { start velosity in true equator }
  td  : extended ; { for current step start  moment in mjd }
  rd  : TVect3 ;   { for current step start  vector position }
  vd  : TVect3 ;   { for current step start  vector velosity }
  te  : extended ; { for current step finish moment in mjd }
  re  : TVect3 ;   { for current step finish vector position }
  ve  : TVect3 ;   { for current step finish vector velosity }
  rz  : TVect3 ;   { current position vector fixed equator }
  vz  : TVect3 ;   { current velosity vector fixed equator }
  zt  : extended ; { time in second for current step of integration }
  rt  : TVect3 ;   { current position in fixed terra system to compare }
begin
  writeln(prtf);
  writeln(prtf,' to restore positions of the selected object');
  writeln(prtf);
  writeln(prtf,'    y  m  d   h  m  s   ',
               '     X(km) (CRS)   Y(km) (CRS)   Z(km) (CRS)',
               '     X(km) (TRS)   Y(km) (TRS)   Z(km) (TRS)');
  writeln(prtf);
  td:=el.t;          { moment as start for integration }
  with  el  do       { initial vector to adjust in rb[1..3] vb[1..3] }
     FromNoradToDesCart(t,ao,au,ai,ae,am,an,dn,td,ra,va); { UnForNor }
  PosVelToFixEqu(td,ra,va,rd,vd); { UnTreRoc init pos vel to fixed equator }
  ds:=600.0; { step in second to integrate by numerical method }
  te:=td;    { value mom for EvergGrator }
  re:=rd;    { value pos for EvergGrator }
  ve:=vd;    { value vel for EvergGrator }
  EverInit ;         { from UnEveRim to start EverGrator }
  EverCoefNullo ;    { from UnEveRim to start EverGrator }
  assign(fr,'xyz.tmp'); { text file with data to compare }
  reset(fr);            { to open to read }
repeat                  { string by string from text file }
  readln(fr,tc,                { current modified julian day with fraction }
            xp,yp,du);         { x y pole position and delta UT }
  While  ( te < (tc-1.0e-8) )  Do { to integrate from UnEveRim }
    PosVelEverGrator(ds,td,rd,vd,te,re,ve);    { from UnEveRim }
  zt:=86400.0*(tc-td);                         { interval in second }
  if  ( zt < ds+1.0e-5)  then                  { out moment is }
    begin                                      { in our interval }
      ClcVectFromPolinom(zt,rd,vd,rz,vz);      { proc from UnEveRim }
      VecToTerra(tc,SecRad*xp,SecRad*yp,du,rz,rt); { to terra system }
      TypeResult(tc,rz,rt); { to write two vectors to text file prtf }
    end;
until  EOF(fr);         { from start to end of file }
  close(fr);            { that is all for this file }
  erase(fr);            { no file xyz.tmp now }
end;
end.
